Index: src/includes/classes/Smarty/sysplugins/smarty_internal_configfilelexer.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_configfilelexer.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_configfilelexer.php	(revision )
@@ -1,6 +1,7 @@
 <?php
 /**
  * Smarty Internal Plugin Configfilelexer
+ *
  * This is the lexer to break the config file source into tokens
  *
  * @package    Smarty
@@ -9,25 +10,134 @@
  */
 
 /**
- * Smarty Internal Plugin Configfilelexer
+ * Smarty_Internal_Configfilelexer
+ *
+ * This is the config file lexer.
+ * It is generated from the smarty_internal_configfilelexer.plex file
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Uwe Tews
  */
 class Smarty_Internal_Configfilelexer
 {
-
+    /**
+     * Source
+     *
+     * @var string
+     */
     public $data;
+
+    /**
+     * byte counter
+     *
+     * @var int
+     */
     public $counter;
+
+    /**
+     * token number
+     *
+     * @var int
+     */
     public $token;
+
+    /**
+     * token value
+     *
+     * @var string
+     */
     public $value;
-    public $node;
+
+    /**
+     * current line
+     *
+     * @var int
+     */
     public $line;
-    private $state = 1;
+
+    /**
+     * state number
+     *
+     * @var int
+     */
+    public $state = 1;
+
+    /**
+     * Smarty object
+     *
+     * @var Smarty
+     */
+    public $smarty = null;
+
+    /**
+     * compiler object
+     *
+     * @var Smarty_Internal_Config_File_Compiler
+     */
+    private $compiler = null;
+
+    /**
+     * copy of config_booleanize
+     *
+     * @var bool
+     */
+    private $configBooleanize = false;
+
+    /**
+     * trace file
+     *
+     * @var resource
+     */
     public $yyTraceFILE;
+
+    /**
+     * trace prompt
+     *
+     * @var string
+     */
     public $yyTracePrompt;
-    public $state_name = array(1 => 'START', 2 => 'VALUE', 3 => 'NAKED_STRING_VALUE', 4 => 'COMMENT', 5 => 'SECTION', 6 => 'TRIPPLE');
+
+    /**
+     * state names
+     *
+     * @var array
+     */
+    public $state_name = array(1 => 'START', 2 => 'VALUE', 3 => 'NAKED_STRING_VALUE', 4 => 'COMMENT', 5 => 'SECTION',
+                               6 => 'TRIPPLE');
+
+    /**
+     * storage for assembled token patterns
+     *
+     * @var sring
+     */
+    private $yy_global_pattern1 = null;
+
+    private $yy_global_pattern2 = null;
+
+    private $yy_global_pattern3 = null;
+
+    private $yy_global_pattern4 = null;
+
+    private $yy_global_pattern5 = null;
+
+    private $yy_global_pattern6 = null;
+
+    /**
+     * token names
+     *
+     * @var array
+     */
-    public $smarty_token_names = array( // Text for parser error messages
+    public $smarty_token_names = array(        // Text for parser error messages
     );
 
-    function __construct($data, $compiler)
+    /**
+     * constructor
+     *
+     * @param   string                             $data template source
+     * @param Smarty_Internal_Config_File_Compiler $compiler
+     */
+    function __construct($data, Smarty_Internal_Config_File_Compiler $compiler)
     {
         // set instance object
         self::instance($this);
@@ -39,6 +149,7 @@
         $this->line = 1;
         $this->compiler = $compiler;
         $this->smarty = $compiler->smarty;
+        $this->configBooleanize = $this->smarty->config_booleanize;
     }
 
     public static function &instance($new_instance = null)
@@ -57,6 +168,7 @@
     }
 
     private $_yy_state = 1;
+
     private $_yy_stack = array();
 
     public function yylex()
@@ -97,41 +209,28 @@
 
     public function yylex1()
     {
-        $tokenMap = array(
-            1 => 0,
-            2 => 0,
-            3 => 0,
-            4 => 0,
-            5 => 0,
-            6 => 0,
-            7 => 0,
-            8 => 0,
-        );
+        if (!isset($this->yy_global_pattern1)) {
+            $this->yy_global_pattern1 = "/\G(#|;)|\G(\\[)|\G(\\])|\G(=)|\G([ \t\r]+)|\G(\n)|\G([0-9]*[a-zA-Z_]\\w*)|\G([\S\s])/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G(#|;)|\G(\\[)|\G(\\])|\G(=)|\G([ \t\r]+)|\G(\n)|\G([0-9]*[a-zA-Z_]\\w*)|\G([\S\s])/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern1, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state START');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state START');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r1_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r1_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -151,8 +250,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -160,52 +258,52 @@
 
     const START = 1;
 
-    function yy_r1_1($yy_subpatterns)
+    function yy_r1_1()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_COMMENTSTART;
         $this->yypushstate(self::COMMENT);
     }
 
-    function yy_r1_2($yy_subpatterns)
+    function yy_r1_2()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_OPENB;
         $this->yypushstate(self::SECTION);
     }
 
-    function yy_r1_3($yy_subpatterns)
+    function yy_r1_3()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_CLOSEB;
     }
 
-    function yy_r1_4($yy_subpatterns)
+    function yy_r1_4()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_EQUAL;
         $this->yypushstate(self::VALUE);
     }
 
-    function yy_r1_5($yy_subpatterns)
+    function yy_r1_5()
     {
 
         return false;
     }
 
-    function yy_r1_6($yy_subpatterns)
+    function yy_r1_6()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NEWLINE;
     }
 
-    function yy_r1_7($yy_subpatterns)
+    function yy_r1_7()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_ID;
     }
 
-    function yy_r1_8($yy_subpatterns)
+    function yy_r1_8()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_OTHER;
@@ -213,42 +311,28 @@
 
     public function yylex2()
     {
-        $tokenMap = array(
-            1 => 0,
-            2 => 0,
-            3 => 0,
-            4 => 0,
-            5 => 0,
-            6 => 0,
-            7 => 0,
-            8 => 0,
-            9 => 0,
-        );
+        if (!isset($this->yy_global_pattern2)) {
+            $this->yy_global_pattern2 = "/\G([ \t\r]+)|\G(\\d+\\.\\d+(?=[ \t\r]*[\n#;]))|\G(\\d+(?=[ \t\r]*[\n#;]))|\G(\"\"\")|\G('[^'\\\\]*(?:\\\\.[^'\\\\]*)*'(?=[ \t\r]*[\n#;]))|\G(\"[^\"\\\\]*(?:\\\\.[^\"\\\\]*)*\"(?=[ \t\r]*[\n#;]))|\G([a-zA-Z]+(?=[ \t\r]*[\n#;]))|\G([^\n]+?(?=[ \t\r]*\n))|\G(\n)/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G([ \t\r]+)|\G(\\d+\\.\\d+(?=[ \t\r]*[\n#;]))|\G(\\d+(?=[ \t\r]*[\n#;]))|\G(\"\"\")|\G('[^'\\\\]*(?:\\\\.[^'\\\\]*)*'(?=[ \t\r]*[\n#;]))|\G(\"[^\"\\\\]*(?:\\\\.[^\"\\\\]*)*\"(?=[ \t\r]*[\n#;]))|\G([a-zA-Z]+(?=[ \t\r]*[\n#;]))|\G([^\n]+?(?=[ \t\r]*\n))|\G(\n)/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern2, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state VALUE');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state VALUE');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r2_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r2_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -268,8 +352,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -277,51 +360,53 @@
 
     const VALUE = 2;
 
-    function yy_r2_1($yy_subpatterns)
+    function yy_r2_1()
     {
 
         return false;
     }
 
-    function yy_r2_2($yy_subpatterns)
+    function yy_r2_2()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_FLOAT;
         $this->yypopstate();
     }
 
-    function yy_r2_3($yy_subpatterns)
+    function yy_r2_3()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_INT;
         $this->yypopstate();
     }
 
-    function yy_r2_4($yy_subpatterns)
+    function yy_r2_4()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_TRIPPLE_QUOTES;
         $this->yypushstate(self::TRIPPLE);
     }
 
-    function yy_r2_5($yy_subpatterns)
+    function yy_r2_5()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_SINGLE_QUOTED_STRING;
         $this->yypopstate();
     }
 
-    function yy_r2_6($yy_subpatterns)
+    function yy_r2_6()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_DOUBLE_QUOTED_STRING;
         $this->yypopstate();
     }
 
-    function yy_r2_7($yy_subpatterns)
+    function yy_r2_7()
     {
 
-        if (!$this->smarty->config_booleanize || !in_array(strtolower($this->value), Array("true", "false", "on", "off", "yes", "no"))) {
+        if (!$this->configBooleanize || !in_array(strtolower($this->value), Array("true", "false", "on", "off", "yes",
+                "no"))
+        ) {
             $this->yypopstate();
             $this->yypushstate(self::NAKED_STRING_VALUE);
             return true; //reprocess in new state
@@ -331,14 +416,14 @@
         }
     }
 
-    function yy_r2_8($yy_subpatterns)
+    function yy_r2_8()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NAKED_STRING;
         $this->yypopstate();
     }
 
-    function yy_r2_9($yy_subpatterns)
+    function yy_r2_9()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NAKED_STRING;
@@ -348,34 +433,28 @@
 
     public function yylex3()
     {
-        $tokenMap = array(
-            1 => 0,
-        );
+        if (!isset($this->yy_global_pattern3)) {
+            $this->yy_global_pattern3 = "/\G([^\n]+?(?=[ \t\r]*\n))/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G([^\n]+?(?=[ \t\r]*\n))/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern3, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state NAKED_STRING_VALUE');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state NAKED_STRING_VALUE');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r3_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r3_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -395,8 +474,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -404,7 +482,7 @@
 
     const NAKED_STRING_VALUE = 3;
 
-    function yy_r3_1($yy_subpatterns)
+    function yy_r3_1()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NAKED_STRING;
@@ -413,36 +491,28 @@
 
     public function yylex4()
     {
-        $tokenMap = array(
-            1 => 0,
-            2 => 0,
-            3 => 0,
-        );
+        if (!isset($this->yy_global_pattern4)) {
+            $this->yy_global_pattern4 = "/\G([ \t\r]+)|\G([^\n]+?(?=[ \t\r]*\n))|\G(\n)/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G([ \t\r]+)|\G([^\n]+?(?=[ \t\r]*\n))|\G(\n)/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern4, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state COMMENT');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state COMMENT');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r4_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r4_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -462,8 +532,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -471,19 +540,19 @@
 
     const COMMENT = 4;
 
-    function yy_r4_1($yy_subpatterns)
+    function yy_r4_1()
     {
 
         return false;
     }
 
-    function yy_r4_2($yy_subpatterns)
+    function yy_r4_2()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NAKED_STRING;
     }
 
-    function yy_r4_3($yy_subpatterns)
+    function yy_r4_3()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_NEWLINE;
@@ -492,35 +561,28 @@
 
     public function yylex5()
     {
-        $tokenMap = array(
-            1 => 0,
-            2 => 0,
-        );
+        if (!isset($this->yy_global_pattern5)) {
+            $this->yy_global_pattern5 = "/\G(\\.)|\G(.*?(?=[\.=[\]\r\n]))/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G(\\.)|\G(.*?(?=[\.=[\]\r\n]))/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern5, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state SECTION');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state SECTION');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r5_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r5_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -540,8 +602,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -549,13 +610,13 @@
 
     const SECTION = 5;
 
-    function yy_r5_1($yy_subpatterns)
+    function yy_r5_1()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_DOT;
     }
 
-    function yy_r5_2($yy_subpatterns)
+    function yy_r5_2()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_SECTION;
@@ -564,35 +625,28 @@
 
     public function yylex6()
     {
-        $tokenMap = array(
-            1 => 0,
-            2 => 0,
-        );
+        if (!isset($this->yy_global_pattern6)) {
+            $this->yy_global_pattern6 = "/\G(\"\"\"(?=[ \t\r]*[\n#;]))|\G([\S\s])/isS";
+        }
         if ($this->counter >= strlen($this->data)) {
             return false; // end of input
         }
-        $yy_global_pattern = "/\G(\"\"\"(?=[ \t\r]*[\n#;]))|\G([\S\s])/iS";
 
         do {
-            if (preg_match($yy_global_pattern, $this->data, $yymatches, null, $this->counter)) {
+            if (preg_match($this->yy_global_pattern6, $this->data, $yymatches, null, $this->counter)) {
                 $yysubmatches = $yymatches;
-                $yymatches = array_filter($yymatches, 'strlen'); // remove empty sub-patterns
-                if (!count($yymatches)) {
-                    throw new Exception('Error: lexing failed because a rule matched' .
-                                        ' an empty string.  Input "' . substr($this->data,
-                                                                              $this->counter, 5) . '... state TRIPPLE');
+                if (strlen($yysubmatches[0]) < 200) {
+                    $yymatches = preg_grep("/(.|\s)+/", $yysubmatches);
+                } else {
+                    $yymatches = array_filter($yymatches, 'strlen');
                 }
+                if (empty($yymatches)) {
+                    throw new Exception('Error: lexing failed because a rule matched' . ' an empty string.  Input "' . substr($this->data, $this->counter, 5) . '... state TRIPPLE');
+                }
                 next($yymatches); // skip global match
                 $this->token = key($yymatches); // token number
-                if ($tokenMap[$this->token]) {
-                    // extract sub-patterns for passing to lex function
-                    $yysubmatches = array_slice($yysubmatches, $this->token + 1,
-                                                $tokenMap[$this->token]);
-                } else {
-                    $yysubmatches = array();
-                }
                 $this->value = current($yymatches); // token value
-                $r = $this->{'yy_r6_' . $this->token}($yysubmatches);
+                $r = $this->{'yy_r6_' . $this->token}();
                 if ($r === null) {
                     $this->counter += strlen($this->value);
                     $this->line += substr_count($this->value, "\n");
@@ -612,8 +666,7 @@
                     continue;
                 }
             } else {
-                throw new Exception('Unexpected input at line' . $this->line .
-                                    ': ' . $this->data[$this->counter]);
+                throw new Exception('Unexpected input at line' . $this->line . ': ' . $this->data[$this->counter]);
             }
             break;
         } while (true);
@@ -621,7 +674,7 @@
 
     const TRIPPLE = 6;
 
-    function yy_r6_1($yy_subpatterns)
+    function yy_r6_1()
     {
 
         $this->token = Smarty_Internal_Configfileparser::TPC_TRIPPLE_QUOTES_END;
@@ -629,7 +682,7 @@
         $this->yypushstate(self::START);
     }
 
-    function yy_r6_2($yy_subpatterns)
+    function yy_r6_2()
     {
 
         $to = strlen($this->data);
@@ -642,5 +695,5 @@
         $this->value = substr($this->data, $this->counter, $to - $this->counter);
         $this->token = Smarty_Internal_Configfileparser::TPC_TRIPPLE_TEXT;
     }
-}
 
+}
Index: src/includes/classes/Smarty/plugins/modifiercompiler.unescape.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.unescape.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.unescape.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/plugins/modifiercompiler.escape.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.escape.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.escape.php	(revision )
@@ -115,11 +115,11 @@
 
     // could not optimize |escape call, so fallback to regular plugin
     if ($compiler->template->caching && ($compiler->tag_nocache | $compiler->nocache)) {
-        $compiler->template->required_plugins['nocache']['escape']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'modifier.escape.php';
-        $compiler->template->required_plugins['nocache']['escape']['modifier']['function'] = 'smarty_modifier_escape';
+        $compiler->parent_compiler->template->compiled->required_plugins['nocache']['escape']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'modifier.escape.php';
+        $compiler->parent_compiler->template->compiled->required_plugins['nocache']['escape']['modifier']['function'] = 'smarty_modifier_escape';
     } else {
-        $compiler->template->required_plugins['compiled']['escape']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'modifier.escape.php';
-        $compiler->template->required_plugins['compiled']['escape']['modifier']['function'] = 'smarty_modifier_escape';
+        $compiler->parent_compiler->template->compiled->required_plugins['compiled']['escape']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'modifier.escape.php';
+        $compiler->parent_compiler->template->compiled->required_plugins['compiled']['escape']['modifier']['function'] = 'smarty_modifier_escape';
     }
 
     return 'smarty_modifier_escape(' . join(', ', $params) . ')';
